//Plugins types
#define PT_NOTHING 0//No returns, No activity (may be for games? 8-)
#define PT_STD 1//Standard 
			     //No input text required
				 //Result in Out_Text 
				 //And text will be inserted
				 //by Plugin
#define PT_MANUAL 2//Like Standard  but text will not be
			     //inserted by Plugin
				 //Editor will insert this text 

typedef struct tagPlugInfo {

	     char Name[255];
         char Menu_Text[50];
         char Ver_Hi;
         char Ver_Lo;
         long int Plugin_Type;

} TPlugInfo, *PPlugInfo;

//Editor Commands
    #define     ecNone             0    // Nothing.  Useful for user event to handle command

	#define     ecLeft             1    // Move cursor left one char
	#define     ecRight            2    // Move cursor right one char
	#define     ecUp               3    // Move cursor up one line
	#define     ecDown             4    // Move cursor down one line
	#define     ecWordLeft         5    // Move cursor left one word
	#define     ecWordRight        6    // Move cursor right one word
	#define     ecLineStart        7    // Move cursor to beginning of line
	#define     ecLineEnd          8    // Move cursor to end of line
	#define     ecPageUp           9    // Move cursor up one page
	#define     ecPageDown         10   // Move cursor down one page
	#define     ecPageLeft         11   // Move cursor right one page
	#define     ecPageRight        12   // Move cursor left one page
	#define     ecPageTop          13   // Move cursor to top of page
	#define     ecPageBottom       14   // Move cursor to bottom of page
	#define     ecEditorTop        15   // Move cursor to absolute beginning
	#define     ecEditorBottom     16   // Move cursor to absolute end
	#define     ecGotoXY           17   // Move cursor to specific coordinates, Data = PPoint

    #define ecSelection        100  // Add this to ecXXX command to get equivalent
                            // command, but with selection enabled. This is not
                            // a command itself.
    // Same as commands above, except they affect selection, too
    #define ecSelLeft          ecLeft + ecSelection
  #define ecSelRight         ecRight + ecSelection
  #define ecSelUp            ecUp + ecSelection
  #define ecSelDown          ecDown + ecSelection
  #define ecSelWordLeft      ecWordLeft + ecSelection
  #define ecSelWordRight     ecWordRight + ecSelection
  #define ecSelLineStart     ecLineStart + ecSelection
  #define ecSelLineEnd       ecLineEnd + ecSelection
  #define ecSelPageUp        ecPageUp + ecSelection
  #define ecSelPageDown      ecPageDown + ecSelection
  #define ecSelPageLeft      ecPageLeft + ecSelection
  #define ecSelPageRight     ecPageRight + ecSelection
  #define ecSelPageTop       ecPageTop + ecSelection
  #define ecSelPageBottom    ecPageBottom + ecSelection
  #define ecSelEditorTop     ecEditorTop + ecSelection
  #define ecSelEditorBottom  ecEditorBottom + ecSelection
  #define ecSelGotoXY        ecGotoXY + ecSelection  // Data = PPoint

  #define ecSelectAll        199  // Select entire contents of editor, cursor to end

  #define ecDeleteLastChar   401  // Delete last char (i.e. backspace key)
  #define ecDeleteChar       402  // Delete char at cursor (i.e. delete key)
  #define ecDeleteWord       403  // Delete from cursor to end of word
  #define ecDeleteLastWord   404  // Delete from cursor to start of word
  #define ecDeleteBOL        405  // Delete from cursor to beginning of line
  #define ecDeleteEOL        406  // Delete from cursor to end of line
  #define ecDeleteLine       407  // Delete current line
  #define ecClearAll         408  // Delete everything
  #define ecLineBreak        409  // Break line at current position, move caret to new line
  #define ecInsertLine       410  // Break line at current position, leave caret
  #define ecChar             411  // Insert a character at current position

  #define ecImeStr           500  // Insert character(s) from IME

  #define ecUndo             601  // Perform undo if available
  #define ecRedo             602  // Perform redo if available
  #define ecCut              603  // Cut selection to clipboard
  #define ecCopy             604  // Copy selection to clipboard
  #define ecPaste            605  // Paste clipboard to current position
  #define ecScrollUp         606  // Scroll up one line leaving cursor position unchanged.
  #define ecScrollDown       607  // Scroll down one line leaving cursor position unchanged.
  #define ecScrollLeft       608  // Scroll left one char leaving cursor position unchanged.
  #define ecScrollRight      609  // Scroll right one char leaving cursor position unchanged.
  #define ecInsertMode       610  // Set insert mode
  #define ecOverwriteMode    611  // Set overwrite mode
  #define ecToggleMode       612  // Toggle ins/ovr mode
  #define ecBlockIndent      613  // Indent selection
  #define ecBlockUnindent    614  // Unindent selection
  #define ecNormalSelect     615  // Normal selection mode
  #define ecColumnSelect     616  // Column selection mode
  #define ecLineSelect       617  // Line selection mode
  #define ecTab              618  // Tab key                                          //wb 1999-11-22
  #define ecShiftTab         619  // Shift+Tab key                                    //mh 1999-12-05
  #define ecMatchBracket     620  // Go to matching bracket                           //ra 2000-01-15

  #define ecGotoMarker0      701  // Goto marker
  #define ecGotoMarker1      702  // Goto marker
  #define ecGotoMarker2      703  // Goto marker
  #define ecGotoMarker3      704  // Goto marker
  #define ecGotoMarker4      705  // Goto marker
  #define ecGotoMarker5      706  // Goto marker
  #define ecGotoMarker6      707  // Goto marker
  #define ecGotoMarker7      708  // Goto marker
  #define ecGotoMarker8      709  // Goto marker
  #define ecGotoMarker9      710  // Goto marker
  #define ecSetMarker0       751  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker1       752  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker2       753  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker3       754  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker4       755  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker5       756  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker6       757  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker7       758  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker8       759  // Set marker, Data = PPoint - X, Y Pos
  #define ecSetMarker9       760  // Set marker, Data = PPoint - X, Y Pos
  #define ecNewDocument      1001 // Create New Document Data
                           	  // type of Document
                           	  // 0 - PHP
                           	  // 1 - HTM
                           	  // 2 - CSS
  #define ecDoSave          1002  // Save Current Document
  #define ecInsertText      1003  //insert big text including carriage return
  #define ecGetDocumentType 1004  //return type of current document
				  // Data points to long int variable
                           // 0 - PHP
                           // 1 - HTM
                           // 2 - CSS
						   // 0xFFFFFFFF - error no document opened!
//typedef void APIENTRY 
typedef void (STDAPICALLTYPE*  lppEditorCommand)(long eCommand,char A,void* Data);
